﻿using System;
using System.Data;
using MySql.Data.MySqlClient;

namespace MySqlError
{
    class Program
    {
        static void Main(string[] args)
        {            
            Console.WriteLine("Enter DB Server Name");
            var serverName = Console.ReadLine();
            Console.WriteLine("Enter DB database name");
            var databaseName = Console.ReadLine();
            Console.WriteLine("Enter SQL username");
            var userName = Console.ReadLine();
            Console.WriteLine("Enter SQL password");
            var password = Console.ReadLine();
            var connectionString = $"SERVER={serverName};DATABASE={databaseName};UID={userName};PASSWORD={password};";            
            MySqlConnection oConn = new MySqlConnection(connectionString);
            MySqlCommand oCmd = new MySqlCommand("slp_json_Insert", oConn);
            MySqlTransaction trx = null;
            oCmd.CommandTimeout = 600;
            try
            {
                oCmd.Parameters.Add(new MySqlParameter { ParameterName = "p_jsonValue", Value = "{\r\n  \"additionalProp1\": [\r\n    null\r\n  ],\r\n  \"additionalProp2\": [\r\n    null\r\n  ],\r\n  \"additionalProp3\": [\r\n    null\r\n  ]\r\n}" });
                oConn.Open();
                trx = oConn.BeginTransaction();
                oCmd.Transaction = trx;
                oCmd.CommandType = CommandType.StoredProcedure;
                oCmd.ExecuteNonQuery();
                trx.Commit();
                oConn.Close(); //Close the connection to the database
                Console.WriteLine("Stored Proc Executed Successfully");
            }
            catch (Exception ex)
            {
                trx?.Rollback();
                Console.WriteLine("MySqlDb::RunStoredProcedure() Error running stored procedure: " + ex);
            }
            finally
            {
                if (oConn.State == ConnectionState.Open) //Check if the connection to the database is open
                {
                    oConn.Close(); //Close the connection to the database 
                }//end if
            }//end finally
            Console.WriteLine("Press Enter To Exit");
            Console.ReadLine();
        } 
    }
}
